---
title: 3D view
slug: Tools/3D_View
tags:
  - HTML
  - Tools
  - Web Development
  - 'Web Development:Tools'
---
<div>{{ToolsSidebar}}</div><div class="warning">
<p>From Firefox 47 onwards, 3D view is no longer available.</p>
</div>

<p>When you click on the 3D view button, the page goes into 3D view mode; in this mode, you can see your page presented in a 3D view in which nested blocks of HTML are increasingly "tall," projecting outward from the bottom of the page. This view makes it easy to visualize the nesting of your content.</p>

<p><img alt="" class="default internal" src="/files/3625/3dview.png"></p>

<p>By clicking and dragging the view, you can rotate and re-orient the 3D presentation of the DOM hierarchy of your page to see it from different angles, to better examine its structure. Off-screen elements become visible, so that you can see where your elements are located in relation to the visible content. You can click on elements to see their HTML in the <a href="/en-US/docs/Tools/Page_Inspector#HTML_pane">HTML panel</a> or the <a href="/en/Tools/Page_Inspector/Style_panel" title="Style panel">Style panel</a>. Conversely, you can click on elements in the breadcrumb bar to change which element is selected in the 3D view.</p>

<p>If you do not see the 3D button in the page inspector, it is possible that your graphics driver needs to be updated. See the <a class="link-https" href="https://wiki.mozilla.org/Blocklisting/Blocked_Graphics_Drivers">blocklisted drivers page</a> for more information.</p>

<h2 id="Controlling_the_3D_view">Controlling the 3D view</h2>

<p>There are keyboard shortcuts and mouse controls available for the 3D view.</p>

<table class="standard-table" style="width: auto;">
 <tbody>
  <tr>
   <td class="header">Function</td>
   <td class="header">Keyboard</td>
   <td class="header">Mouse</td>
  </tr>
  <tr>
   <td>Zoom in/out</td>
   <td><kbd>+</kbd> / <kbd>-</kbd></td>
   <td>Scroll wheel up/down</td>
  </tr>
  <tr>
   <td>Rotate left/right</td>
   <td><kbd>a</kbd> / <kbd>d</kbd></td>
   <td>Mouse left/right</td>
  </tr>
  <tr>
   <td>Rotate up/down</td>
   <td><kbd>w</kbd> / <kbd>s</kbd></td>
   <td>Mouse up/down</td>
  </tr>
  <tr>
   <td>Pan left/right</td>
   <td><kbd>←</kbd> / <kbd>→</kbd></td>
   <td>Mouse left/right</td>
  </tr>
  <tr>
   <td>Pan up/down</td>
   <td><kbd>↑</kbd> / <kbd>↓</kbd></td>
   <td>Mouse up/down</td>
  </tr>
  <tr>
   <td>Reset zoom level</td>
   <td><kbd>0</kbd></td>
   <td>Resets the zoom level to the default</td>
  </tr>
  <tr>
   <td>Focus on selected node</td>
   <td><kbd>f</kbd></td>
   <td>Makes sure the currently selected node is visible {{ fx_minversion_inline("13.0") }}</td>
  </tr>
  <tr>
   <td>Reset view</td>
   <td><kbd>r</kbd></td>
   <td>Resets zoom, rotation, and panning to the default {{ fx_minversion_inline("12.0") }}</td>
  </tr>
  <tr>
   <td>Hide current node</td>
   <td><kbd>x</kbd></td>
   <td>Makes the currently selected node invisible; this can be helpful if you need to get at a node that's obscured {{ fx_minversion_inline("12.0") }}</td>
  </tr>
 </tbody>
</table>

<h2 id="Use_cases_for_the_3D_view">Use cases for the 3D view</h2>

<p>There are a variety of ways the 3D view is useful:</p>

<ul>
 <li>If you have broken HTML causing layout problems, looking at the 3D view can help find where you've gone wrong. Often, layout problems are caused by improper nesting of content. This can become much more obvious when looking at the 3D view and seeing where your elements are nested wrong.</li>
 <li>If content isn't displaying, you may be able to figure out why; since the 3D view lets you zoom out to see elements that are rendering outside the visible area of the page, you can find stray content this way.</li>
 <li>You can get a look at how your page is structured to see if there may be ways to optimize your layout.</li>
 <li>And, of course, it looks <strong>awesome</strong>.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en/Tools/Page_Inspector" title="Page Inspector">Page Inspector</a></li>
 <li><a href="/en/Tools/Page_Inspector/HTML_panel" title="HTML panel">HTML panel</a></li>
 <li>
  <div class="threecolumns">
  <p><a href="/en/Tools/Page_Inspector/Style_panel" title="en/Tools/Page_Inspector/Style panel">Style panel</a></p>
  </div>
 </li>
 <li><a href="/en/Tools" title="Tools">Tools</a></li>
 <li><a class="external" href="http://hacks.mozilla.org/2011/12/new-developer-tools-in-firefox-11-aurora/">New Developer Tools in Firefox 11 Aurora</a> (blog post)</li>
</ul>
